/*
      Algorithm AS66 Applied Statistics (1973) vol22 no.3
      Evaluates the tail area of the standardised normal curve
      from x to infinity if upper is .true. or
      from minus infinity to x if upper is .false.
*/

#include <math.h>

float stdnorm(float x) {
  return (1.0/sqrt(2*3.141592653))*exp(-0.5*x*x);
}

float alnorm(float x, int upper) {
  float q;

  float stdnorm(float x);
  extern float qtrap(float (*func)(float x), float a, float b);
  
  if (x==0.0) q=0;
  else q=qtrap(&stdnorm, 0, x);

  if (upper) q=1.0-q-0.5;
  else q+=0.5;
 
  return(q);
}
