#include <Xm/MessageB.h>
#include <Xm/RowColumn.h>
#include <Xm/Form.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/Frame.h>
#include <Xm/LabelG.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <string.h>
#include <math.h>
#include "global.h"
#include "messages.h"
#include "nrutil.h"

/* Structure for ttests */
typedef struct {
  int  nlist1, nlist2;
  int  *list1, *list2;
  int  utt_group_var;
} ttest_struct;


void add_line(char *text, int n) {
  int i;
  for (i=0; i<n; i++) strcat(text, "-");
  strcat(text, "\n");
}

void s_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  static ttest_struct  *ttest;
  static Widget list_w[3];
  Widget        toplevel, dialog, form, rc, add1_w, add2_w, rem1_w, rem2_w, w;
  int           item, i, j, k;
  int           rows, cols;
  int           n, startgroup;
  float         *data, wert;
  float         ave, adev, sdev, var, skew, curt, min, max;
  float         *data1, *data2, wert1, wert2;
  float         sx, sy, sx2, sy2, sxy;
  float         qx, qy, qxy;
  float         r, r2, by, bx, ay, ax, s2yx, s2xy;
  char          *pcells1, *pcells2;
  char          *out_buf, temp[256], text[256], *pcells;
  String        **cells, *clabels;
  Arg           args[5];
  short         is_sort;
  XmStringTable dep_list;
  int           dep_count;

  extern void moment(float data[], unsigned long n,
		     float *ave, float *adev, float *sdev, float *var,
		     float *skew, float *curt);
  extern float prho(int n, float is, int *ifault);
  extern void resedit(char *text, char *title);
  void ptt_ok_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void add1_ptt_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void add2_ptt_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void rem1_ptt_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void rem2_ptt_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void utt_ok_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void group_utt_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  void elem_utt_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  extern void cancel_cb(Widget, XtPointer, XtPointer);
  extern void showmess(Widget widget, char *title, char *text);

  toplevel=XtParent(widget);
  while (!XtIsTopLevelShell(toplevel)) toplevel=XtParent(toplevel);
  item=(int) client_data;
  out_buf=new char  [OUTBUFLEN]; strcpy(out_buf,"");
  data   =new float [DATALEN];
  data1  =new float [DATALEN];
  data2  =new float [DATALEN];
  XtVaGetValues(StatData, XmNcolumns, &cols, NULL);
  XtVaGetValues(StatData, XmNrows, &rows, NULL);
  XtVaGetValues(StatData, XmNcolumnLabels, &clabels, NULL);
  XtVaGetValues(StatData, XmNcells, &cells, NULL);
  if (!ttest) {
    ttest=new ttest_struct;
    ttest->nlist1=0; ttest->nlist2=0;
    ttest->list1=new int[1];
    ttest->list2=new int[1];
    ttest->utt_group_var=0;
  }
  switch(item) {
  case 0:      // data listing;
    if (sort.nsort+sort.ndep>0) {
      if (sort.ngroup==1) sort.group[0]=rows;
      strcpy(out_buf, "Data Listing \n\n");
      /* Headline */
      add_line(out_buf, (sort.nsort+sort.ndep)*11+4);
      strcat(out_buf, "obs. ");
      for (i=0; i<sort.nsort; i++) {
	strncpy(text, clabels[sort.sort[i]], 10);
	sprintf(temp, "%10s ", text);
	strcat(out_buf, temp);
      }
      for (i=0; i<sort.ndep; i++) {
	strncpy(text, clabels[sort.dep[i]], 10);
	sprintf(temp, "%10s ", text);
	strcat(out_buf, temp);
      }
      strcat(out_buf, "\n");
      add_line(out_buf, (sort.nsort+sort.ndep)*11+4);
      startgroup=0;
      for (k=0; k<sort.ngroup; k++) {
	/* print rows for each group */
	for (j=startgroup; j<startgroup+sort.group[k]; j++) {
	  sprintf(temp, "%4d ", j+1);
	  strcat(out_buf, temp);
	  for (i=0; i<sort.nsort; i++) {
	    sprintf(temp, "%10s ", cells[j][sort.sort[i]]);
	    strcat(out_buf, temp);
	  }
	  for (i=0; i<sort.ndep; i++) {
	    sprintf(temp, "%10s ", cells[j][sort.dep[i]]);
	    strcat(out_buf, temp);
	  }
	  strcat(out_buf, "\n");
	}
	add_line(out_buf, (sort.nsort+sort.ndep)*11+4);
	startgroup+=sort.group[k];
      }
      strcat(out_buf, "\n");
      resedit(out_buf, "data listing");
    }
    else {
      showmess(StatData, LIST_NOVAR_T, LIST_NOVAR_M);
    }
    break;
  case 1:      // descriptive statistics;
    if (sort.ndep>0) {
      if (sort.ngroup==1) sort.group[0]=rows;
      strcpy(out_buf, "Descriptive Statistics \n\n");
      startgroup=0;
      for (k=0; k<sort.ngroup; k++) {
	/* Headline */
	for (i=0; i<sort.nsort; i++) {
	  sprintf(temp, "%10s = %10s \n", clabels[sort.sort[i]], cells[startgroup][sort.sort[i]] );
	  strcat(out_buf, temp);
	}
	add_line(out_buf, 74);
	sprintf(temp,
		"%10s%4s%10s%10s%10s%10s%10s%10s\n",
		"variable", "n", "min", "mean", "max", "var", "sdev", "sem");
	strcat(out_buf, temp);
	add_line(out_buf, 74);
	/* Results */
	for (i=0; i<sort.ndep; i++) {
	  n=0; min=1e30; max=-1e30;
	  for (j=startgroup; j<startgroup+sort.group[k]; j++) {
	    /* get data array */
	    wert=strtod(cells[j][sort.dep[i]], &pcells);
	    if (wert!=0 || strcmp(pcells,cells[j][sort.dep[i]])) {
	      data[n]=wert;
	      if (wert>max) max=wert;
	      if (wert<min) min=wert;
	      n++;
	    }
	  }
	  if (n>1) {
	    moment(data-1, n, &ave, &adev, &sdev, &var, &skew, &curt);
	    strncpy(text,clabels[sort.dep[i]], 10);
	    sprintf(temp, "%10s%4d%10.3f%10.3f%10.3f%10.3f%10.3f%10.3f\n",
		    text, n, min, ave, max, var, sdev, sqrt(var/n));
	    strcat(out_buf, temp);
	  }
	  else if (n==1) {
	    strncpy(text,clabels[sort.dep[i]], 10);
	    sprintf(temp, "%10s%4d%10.3f%10.3f%10.3f%10.3f%10.3f%10.3f\n",
		    text, n, data[0], data[0], data[0], 0.0, 0.0, 0.0);
	    strcat(out_buf, temp);
	  }
	}
	startgroup+=sort.group[k];
	strcat(out_buf, "\n");
      }
      resedit(out_buf, "descriptive statistics");
    }
    else {
      showmess(StatData, DES_NODEP_T, DES_NODEP_M);
    }
    break;
  case 2:      // regression;
    if (sort.ndep==2) {
      if (sort.ngroup==1) sort.group[0]=rows;
      strcpy(out_buf, "Correlation and Regression Analysis \n\n");
      sprintf(temp, "X-variable: %10s\nY-variable: %10s\n\n",
	      clabels[sort.dep[0]], clabels[sort.dep[1]]);
      strcat(out_buf, temp);
      startgroup=0;
      for (k=0; k<sort.ngroup; k++) {
	/* Headline */
	for (i=0; i<sort.nsort; i++) {
	  sprintf(temp, "%10s = %10s \n",
		  clabels[sort.sort[i]], cells[startgroup][sort.sort[i]] );
	  strcat(out_buf, temp);
	}
	add_line(out_buf, 63);
	/* Results */
	n=0;
	for (j=startgroup; j<startgroup+sort.group[k]; j++) {
	  /* get data array */
	  wert1=strtod(cells[j][sort.dep[0]], &pcells1);
	  wert2=strtod(cells[j][sort.dep[1]], &pcells2);
	  if ((wert1!=0 || strcmp(pcells1,cells[j][sort.dep[0]])) &&
	      (wert2!=0 || strcmp(pcells2,cells[j][sort.dep[1]]))) {
	    data1[n]=wert1;
	    data2[n]=wert2;
	    n++;
	  }
	}
	if (n>2) {
	  sx2=0; sy2=0; sx=0; sy=0; sxy=0;
	  for (i=0; i<n; i++) {
	    sx2+=(data1[i]*data1[i]); sy2+=(data2[i]*data2[i]);
	    sxy+=(data1[i]*data2[i]);
	    sx+=data1[i]; sy+=data2[i];
	  }
	  qx=sx2-(sx*sx/n); qy=sy2-(sy*sy/n); qxy=sxy-(sx*sy/n);
	  r=qxy/sqrt(qx*qy);
	  by=qxy/qx; bx=qxy/qy;
	  ay=(sy-by*sx)/n; ax=(sx-bx*sy)/n;
	  s2yx=(qy-(qxy*qxy/qx))/(n-2);
	  s2xy=(qx-(qxy*qxy/qy))/(n-2);
	  sprintf(temp, "x->y: y = %13.6f + %13.6f * x; s2yx=%13.6f\n", ay, by, s2yx);
	  strcat(out_buf, temp);
	  sprintf(temp, "y->x: x = %13.6f + %13.6f * y; s2xy=%13.6f\n", ax, bx, s2xy);
	  strcat(out_buf, temp);
	  sprintf(temp, "number of data pairs            (n)   = %d\n", n);
	  strcat(out_buf, temp);
 	  sprintf(temp, "correlation coefficient         (r)   =%9.6f\n", r);
	  strcat(out_buf, temp);
	  sprintf(temp, "squared correlation coefficient (r^2) =%9.6f\n", by*bx);
	  strcat(out_buf, temp);
	  wert=2*(1.0-prho(n, (n*n*n-n)*(1.0-fabs(r))/6.0, &i));
	  if (wert>1.0) wert=1.0;
	  if (wert<0.0) wert=0.0;
	  sprintf(temp, "probability for alpha error     (p)   =%9.6f (two tailed)\n",wert);
	  strcat(out_buf, temp);
	}
	strcat(out_buf, "\n");
	startgroup+=sort.group[k];
      }	
      resedit(out_buf, "Correlation and Regression Analysis");
    }
    else {
      showmess(StatData, REG_NVAR_T, REG_NVAR_M);
    }
    break;
  case 3:      // paired t-test;
    /* create dialog */
    i=0;
    XtSetArg(args[i], XmNdialogTitle,
	     XmStringCreateLocalized("paired t-test"));
    i++;
    XtSetArg(args[i], XmNmessageString,
	     XmStringCreateLocalized("select pairs of variables:"));
    i++;
    XtSetArg(args[i], XmNautoUnmanage, False); i++;
    dialog=XmCreateMessageDialog(toplevel, "dialog", args, i);
    XtUnmanageChild(XmMessageBoxGetChild(dialog, XmDIALOG_HELP_BUTTON));
    form=XtVaCreateWidget("form", xmFormWidgetClass, dialog,
			  NULL);
    /* create buttons */
    rem1_w=XtVaCreateManagedWidget("remove from list 1",xmPushButtonWidgetClass, form,
				   XmNwidth, 150,
				   XmNleftAttachment, XmATTACH_FORM,
				   XmNbottomAttachment, XmATTACH_FORM,
				   NULL);
    rem2_w=XtVaCreateManagedWidget("remove from list 2",xmPushButtonWidgetClass, form,
				   XmNwidth, 150,
				   XmNrightAttachment, XmATTACH_FORM,
				   XmNbottomAttachment, XmATTACH_FORM,
				   NULL);
    XtAddCallback(rem1_w, XmNactivateCallback, rem1_ptt_cb, (XtPointer)ttest);
    XtAddCallback(rem2_w, XmNactivateCallback, rem2_ptt_cb, (XtPointer)ttest);
    add1_w=XtVaCreateManagedWidget("add to list 1",xmPushButtonWidgetClass, form,
				   XmNwidth, 150,
				   XmNleftAttachment, XmATTACH_FORM,
				   XmNbottomAttachment, XmATTACH_WIDGET,
				   XmNbottomWidget, rem1_w,
				   NULL);
    add2_w=XtVaCreateManagedWidget("add to list 2",xmPushButtonWidgetClass, form,
				   XmNwidth, 150,
				   XmNrightAttachment, XmATTACH_FORM,
				   XmNbottomAttachment, XmATTACH_WIDGET,
				   XmNbottomWidget, rem2_w,
				   NULL);
    XtAddCallback(add1_w, XmNactivateCallback, add1_ptt_cb, (XtPointer)ttest);
    XtAddCallback(add2_w, XmNactivateCallback, add2_ptt_cb, (XtPointer)ttest);
    /* create list1 */
    ttest->nlist1=0;
    w=XtVaCreateManagedWidget("frame", xmFrameWidgetClass, form,
			      XmNshadowType, XmSHADOW_OUT,
			      NULL);
    XtVaCreateManagedWidget("list 1", xmLabelGadgetClass, w,
			    XmNchildType, XmFRAME_TITLE_CHILD,
			    XmNchildHorizontalAlignment, XmALIGNMENT_BEGINNING,
			    XmNchildVerticalAlignment, XmALIGNMENT_WIDGET_TOP,
			    NULL);
    i=0;
    XtSetArg(args[i], XmNlistSizePolicy, XmCONSTANT); i++;
    XtSetArg(args[i], XmNvisibleItemCount, 5); i++;
    XtSetArg(args[i], XmNselectionPolicy, XmEXTENDED_SELECT); i++;
    list_w[1]=XmCreateScrolledList(w, "list1", args, i);
    XtVaSetValues(XtParent(list_w[1]), XmNwidth, 150, NULL);
    XtManageChild(list_w[1]);
    XtVaSetValues(w,
		  XmNleftAttachment, XmATTACH_FORM,
		  XmNbottomAttachment, XmATTACH_WIDGET,
		  XmNbottomWidget, add1_w,
		  NULL);
    /* create list2 */
    ttest->nlist2=0;
    w=XtVaCreateManagedWidget("frame", xmFrameWidgetClass, form,
			      XmNshadowType, XmSHADOW_OUT,
			      NULL);
    XtVaCreateManagedWidget("list 2", xmLabelGadgetClass, w,
			    XmNchildType, XmFRAME_TITLE_CHILD,
			    XmNchildHorizontalAlignment, XmALIGNMENT_BEGINNING,
			    XmNchildVerticalAlignment, XmALIGNMENT_WIDGET_TOP,
			    NULL);
    i=0;
    XtSetArg(args[i], XmNlistSizePolicy, XmCONSTANT); i++;
    XtSetArg(args[i], XmNvisibleItemCount, 5); i++;
    XtSetArg(args[i], XmNselectionPolicy, XmEXTENDED_SELECT); i++;
    list_w[2]=XmCreateScrolledList(w, "list2", args, i);
    XtVaSetValues(XtParent(list_w[2]), XmNwidth, 150, NULL);
    XtManageChild(list_w[2]);
    XtVaSetValues(w,
		  XmNrightAttachment, XmATTACH_FORM,
		  XmNbottomAttachment, XmATTACH_WIDGET,
		  XmNbottomWidget, add2_w,
		  NULL);
    /* create list of all that are not sort */
    if (cols-sort.nsort>0) {
      dep_list=(XmStringTable) XtMalloc ((cols-sort.nsort) * sizeof(XmString));
      dep_count=0;
      for (i=0; i<cols; i++) {
	is_sort=0;
	for (j=0; j<sort.nsort; j++) {
	  if (i==sort.sort[j]) is_sort=1;
	}
	if (!is_sort) {
	  dep_list[dep_count]=XmStringCreateLocalized(clabels[i]);
	  dep_count++;
	}
      }
    }
    w=XtVaCreateManagedWidget("frame", xmFrameWidgetClass, form,
			      XmNshadowType, XmSHADOW_OUT,
			      NULL);
    list_w[0]=XmCreateScrolledList(w, "alllist", NULL, 0);
    XtVaSetValues(list_w[0],
		  XmNvisibleItemCount, 5,
		  XmNselectionPolicy, XmEXTENDED_SELECT,
		  NULL);
    XtVaSetValues(XtParent(list_w[0]), XmNwidth, 320, NULL);
    XtVaSetValues(w,
		  XmNtopAttachment, XmATTACH_FORM,
		  XmNleftAttachment, XmATTACH_FORM,
		  XmNrightAttachment, XmATTACH_FORM,
		  XmNbottomAttachment, XmATTACH_WIDGET,
		  XmNbottomWidget, XtParent(XtParent(list_w[1])),
		  NULL);
    if (cols-sort.nsort>0) {
      XtVaSetValues(list_w[0],
		  XmNitemCount, (cols-sort.nsort),
		  XmNitems, dep_list,
		  NULL);
    }
    XtManageChild(list_w[0]);
    /* manage everything */
    XtManageChild(form);
    XtManageChild(dialog);
    XtAddCallback(dialog, XmNokCallback, ptt_ok_cb, (XtPointer)ttest);
    XtAddCallback(dialog, XmNcancelCallback, cancel_cb, (XtPointer)ttest);
    XtVaSetValues(add1_w, XmNuserData, list_w, NULL);
    XtVaSetValues(add2_w, XmNuserData, list_w, NULL);
    XtVaSetValues(rem1_w, XmNuserData, list_w, NULL);
    XtVaSetValues(rem2_w, XmNuserData, list_w, NULL);
    XtPopup(XtParent(dialog), XtGrabNone);
    break;
  case 4:      // unpaired t-test;
    if (sort.ndep>0) {
      i=0;
      XtSetArg(args[i], XmNdialogTitle,
	       XmStringCreateLocalized("unpaired t-test"));
      i++;
      XtSetArg(args[i], XmNmessageString,
	       XmStringCreateLtoR("1. Select one variable that defines the two groups.\n2. Select two levels for comparison.",XmFONTLIST_DEFAULT_TAG));
      i++;
      XtSetArg(args[i], XmNautoUnmanage, False); i++;
      dialog=XmCreateMessageDialog(toplevel, "dialog", args, i);
      XtUnmanageChild(XmMessageBoxGetChild(dialog, XmDIALOG_HELP_BUTTON));
      XtVaSetValues(dialog,
		    XmNheight, 350,
		    XmNuserData, ttest,
		    NULL);

      rc=XtVaCreateWidget("rc", xmRowColumnWidgetClass, dialog,
			  XmNorientation, XmHORIZONTAL,
			  NULL);
      /* create list for selection of group variable  */
      if (cols-sort.nsort-sort.ndep>0) {
	dep_list=(XmStringTable)XtMalloc((cols-sort.nsort-sort.ndep)
					 * sizeof(XmString));
	dep_count=0;
	for (i=0; i<cols; i++) {
	  is_sort=0;
	  for (j=0; j<sort.nsort; j++) if (i==sort.sort[j]) is_sort=1;
	  for (j=0; j<sort.ndep; j++)  if (i==sort.dep[j]) is_sort=1;
	  if (!is_sort) {
	    dep_list[dep_count]=XmStringCreateLocalized(clabels[i]);
	    dep_count++;
	  }
	}
      }
      w=XtVaCreateManagedWidget("frame", xmFrameWidgetClass, rc,
				XmNshadowType, XmSHADOW_OUT,
				NULL);
      XtVaCreateManagedWidget("group variable", xmLabelGadgetClass, w,
			      XmNchildType, XmFRAME_TITLE_CHILD,
			      XmNchildHorizontalAlignment, XmALIGNMENT_BEGINNING,
			      XmNchildVerticalAlignment, XmALIGNMENT_WIDGET_TOP,
			      NULL);
      list_w[1]=XmCreateScrolledList(w, "deplist", NULL, 0);
      XtVaSetValues(list_w[1],
		    XmNchildType, XmFRAME_WORKAREA_CHILD,
		    XmNselectionPolicy, XmSINGLE_SELECT,
		    XmNuserData, ttest,
		    NULL);
      if (cols-sort.nsort-sort.ndep>0) {
	XtVaSetValues(list_w[1],
		      XmNitemCount, (cols-sort.nsort-sort.ndep),
		      XmNitems, dep_list,
		      NULL);
      }
      w=XtVaCreateManagedWidget("frame", xmFrameWidgetClass, rc,
				XmNshadowType, XmSHADOW_OUT,
				NULL);
      XtVaCreateManagedWidget("levels of group variable", xmLabelGadgetClass, w,
			      XmNchildType, XmFRAME_TITLE_CHILD,
			      XmNchildHorizontalAlignment, XmALIGNMENT_BEGINNING,
			      XmNchildVerticalAlignment, XmALIGNMENT_WIDGET_TOP,
			      NULL);
      list_w[2]=XmCreateScrolledList(w,"sortlist", NULL, 0);
      XtVaSetValues(list_w[2],
		    XmNchildType, XmFRAME_WORKAREA_CHILD,
		    XmNselectionPolicy, XmMULTIPLE_SELECT,
		    NULL);
      XtAddCallback(list_w[1], XmNsingleSelectionCallback, group_utt_cb, list_w);
      XtVaGetValues(list_w[1], XmNitemCount, &dep_count, NULL);
      if (dep_count>0) XmListSelectPos(list_w[1], 1, True);
      XtManageChild(list_w[1]);
      XtManageChild(list_w[2]);
      XtManageChild(rc);
      XtAddCallback(dialog, XmNokCallback, utt_ok_cb, list_w);
      XtAddCallback(dialog, XmNcancelCallback, cancel_cb, list_w);
      XtManageChild(dialog);
      XtPopup(XtParent(dialog), XtGrabNone);

      if (cols-sort.nsort-sort.ndep > 0) {
	for (i=0; i<(cols-sort.nsort-sort.ndep); i++) XmStringFree(dep_list[i]);
	XtFree((char *)dep_list);
      }
    }
    else {
      showmess(StatData, UTT_NOVAR_T, UTT_NOVAR_M);
    }
    break;
  }

  delete [] out_buf;
  delete [] data;
}


/* ..................................*/
/* .....   C a l l b a c k s   ..... */
/* ................................. */

/* paired t-test ok callback */
void ptt_ok_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  String        **cells, *clabels;
  ttest_struct  *ttest;
  char          *out_buf, *temp, *pcells, var1[15], var2[15];
  int           k, i, j;
  int           startgroup, rows;
  float         *data1, *data2;
  float         t, p, aved, sd, t95;
  unsigned long ndata;

  extern void resedit(char *text, char *title);
  extern void mytptest(float data1[], float data2[], unsigned long n,
		     float *t, float *prob, float *aved, float *sd);
  extern void getstudt(float df, float p, float *t);
  extern void showmess(Widget widget, char *title, char *text);

  ttest=(ttest_struct *) client_data;
  out_buf=new char [OUTBUFLEN];
  temp   =new char [256];
  XtVaGetValues(StatData, XmNrows, &rows, NULL);
  XtVaGetValues(StatData, XmNcolumnLabels, &clabels, NULL);
  XtVaGetValues(StatData, XmNcells, &cells, NULL);

  if (ttest->nlist1 == ttest->nlist2) {
    strcpy(out_buf, "Paired Differences Student's t-test \n\n");
    if (sort.ngroup==1) sort.group[0]=rows;
    startgroup=0;
    for (k=0; k<sort.ngroup; k++) {
      /* Headline */
      for (i=0; i<sort.nsort; i++) {
	sprintf(temp, "%10s = %10s \n", clabels[sort.sort[i]], cells[startgroup][sort.sort[i]] );
	strcat(out_buf, temp);
      }
      add_line(out_buf, 75);
      sprintf(temp,
	      "%10s %10s %4s %4s %10s %10s %10s %10s\n",
	      "variable 1", "variable 2", "n", "df", "t", "p", "CI low", "CI high");
      strcat(out_buf, temp);
      add_line(out_buf, 75);
      /* Results */
      data1=new float[sort.group[k]];
      data2=new float[sort.group[k]];
      for (i=0; i<ttest->nlist1; i++) {
	ndata=0;
	// get data array;
	for (j=startgroup; j<startgroup+sort.group[k]; j++) {
	  data1[ndata]=strtod(cells[j][ttest->list1[i]], &pcells);
	  data2[ndata]=strtod(cells[j][ttest->list2[i]], &pcells);
	  // are both values numeric ?;
	  if ((data1[ndata]!=0 || strcmp(pcells,cells[j][ttest->list1[i]])) &&
	      (data2[ndata]!=0 || strcmp(pcells,cells[j][ttest->list2[i]]))) {
	    ndata++;
	  }
	}
	if (ndata>1) {
	  strncpy(var1, clabels[ttest->list1[i]], 10); var1[10]='\0';
	  strncpy(var2, clabels[ttest->list2[i]], 10); var2[10]='\0';
	  mytptest(data1-1, data2-1, ndata, &t, &p, &aved, &sd);
	  getstudt(ndata-1, 0.05, &t95);
	  sprintf(temp, "%10s %10s %4d %4d %10.3f %10.3f %10.3f %10.3f\n",
		  var1, var2, ndata, ndata-1, fabs(t), p, aved-t95*sd, aved+t95*sd);
	  strcat(out_buf, temp);
	}
      }
      delete[]data1; delete[]data2;
      startgroup+=sort.group[k];
      add_line(out_buf, 75);
      strcat(out_buf, "\n");
    }
    XtUnmanageChild(widget);
    resedit(out_buf, "paired t-test");
  } /* if nlist1==nlist2 */
  else {
    showmess(widget, PTT_NERR_T,  PTT_NERR_M);
  }
  delete[]temp;
  delete[]out_buf;
}

/* add to a list of paired tt-test variables */
void add1_ptt_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  Widget        *list_w;
  ttest_struct  *ttest;
  XmStringTable listitems;
  int           listn;
  String        *lcol;
  char          *text;
  int           i, j, cols;

  XtVaGetValues(StatData, XmNcolumns, &cols, NULL);
  XtVaGetValues(StatData, XmNcolumnLabels, &lcol, NULL);
  ttest=(ttest_struct *) client_data;
  XtVaGetValues(widget, XmNuserData, &list_w, NULL);
  text=new char[255];

  XtVaGetValues(list_w[0],
		XmNitems, &listitems,
		XmNitemCount, &listn,
		NULL);
  for (i=0; i<listn; i++) {
    if (XmListPosSelected(list_w[0],i+1)) {
      XmStringGetLtoR(listitems[i], XmFONTLIST_DEFAULT_TAG, &text);
      for (j=0; j<cols; j++) {
	if (!strcmp(lcol[j], text)) {
	  /* add this item */
	  //	strncpy(text, text, 20);
	  XmListAddItem(list_w[1], XmStringCreateLocalized(text), 0);
	  ttest->nlist1++;
	  ttest->list1=(int *) realloc(ttest->list1, ttest->nlist1*sizeof(int));
	  ttest->list1[ttest->nlist1-1]=j;
	}
      }
    }
  }
  delete [] text;
}

void add2_ptt_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  Widget        *list_w;
  ttest_struct  *ttest;
  XmStringTable listitems;
  int           listn;
  String        *lcol;
  char          *text;
  int           i, j, cols;

  XtVaGetValues(StatData, XmNcolumns, &cols, NULL);
  XtVaGetValues(StatData, XmNcolumnLabels, &lcol, NULL);
  ttest=(ttest_struct *) client_data;
  XtVaGetValues(widget, XmNuserData, &list_w, NULL);
  text=new char[255];

  XtVaGetValues(list_w[0],
		XmNitems, &listitems,
		XmNitemCount, &listn,
		NULL);
  for (i=0; i<listn; i++) {
    if (XmListPosSelected(list_w[0],i+1)) {
      XmStringGetLtoR(listitems[i], XmFONTLIST_DEFAULT_TAG, &text);
      for (j=0; j<cols; j++) {
	if (!strcmp(lcol[j], text)) {
	  /* add this item */
	  //	strncpy(text, text, 20);
	  XmListAddItem(list_w[2], XmStringCreateLocalized(text), 0);
	  ttest->nlist2++;
	  ttest->list2=(int *) realloc(ttest->list2, ttest->nlist2*sizeof(int));
	  ttest->list2[ttest->nlist2-1]=j;
	}
      }
    }
  }
  delete [] text;
}

/* remove from a list of paired tt-test variables */
void rem1_ptt_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  Widget        *list_w;
  ttest_struct  *ttest;
  XmStringTable listitems;
  int           listn, i, j;

  ttest=(ttest_struct *) client_data;
  XtVaGetValues(widget, XmNuserData, &list_w, NULL);

  XtVaGetValues(list_w[1],
		XmNitems, &listitems,
		XmNitemCount, &listn,
		NULL);
  for (i=0; i<listn; i++) {
    if (XmListPosSelected(list_w[1],i+1)) {
      XmListDeletePos(list_w[1], i+1);
      for (j=i; j<ttest->nlist1-1; j++) ttest->list1[j]=ttest->list1[j+1];
      ttest->nlist1--;
      ttest->list1=(int *) realloc(ttest->list1, ttest->nlist1*sizeof(int));
      i--; listn--;
    }
  }
}

void rem2_ptt_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  Widget        *list_w;
  ttest_struct  *ttest;
  XmStringTable listitems;
  int           listn, i, j;

  ttest=(ttest_struct *) client_data;
  XtVaGetValues(widget, XmNuserData, &list_w, NULL);

  XtVaGetValues(list_w[2],
		XmNitems, &listitems,
		XmNitemCount, &listn,
		NULL);
  for (i=0; i<listn; i++) {
    if (XmListPosSelected(list_w[2],i+1)) {
      XmListDeletePos(list_w[2], i+1);
      for (j=i; j<ttest->nlist2-1; j++) ttest->list2[j]=ttest->list2[j+1];
      ttest->nlist2--;
      ttest->list2=(int *) realloc(ttest->list2, ttest->nlist2*sizeof(int));
      i--; listn--;
    }
  }
}

void group_utt_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  XmListCallbackStruct *cbs=(XmListCallbackStruct *) call_data;
  Widget               *list_w, toplevel;
  ttest_struct         *ttest;
  String               **cells, *clabels;
  char                 *text;
  short                is_new;
  int                  i, j, cols, rows, group_n, elem_n;

  extern void showmess(Widget widget, char *title, char *text);

  list_w=(Widget *)client_data;
  XtVaGetValues(widget, XmNuserData, &ttest, NULL);
  XtVaGetValues(StatData, XmNcolumns, &cols, NULL);
  XtVaGetValues(StatData, XmNrows, &rows, NULL);
  XtVaGetValues(StatData, XmNcolumnLabels, &clabels, NULL);
  XtVaGetValues(StatData, XmNcells, &cells, NULL);
  toplevel=XtParent(widget);
  while (!XtIsTopLevelShell(toplevel)) toplevel=XtParent(toplevel);

  XmStringGetLtoR(cbs->item, XmFONTLIST_DEFAULT_TAG, &text);
  group_n=-1;
  for (i=0; i<cols; i++) {
    if (!strcmp(text, clabels[i])) group_n=i;
  }
  ttest->utt_group_var=group_n;
  XtFree(text);

  if (rows>0) {
    XmListDeleteAllItems(list_w[2]);
    if (strtok(cells[0][group_n]," \t\n\0"))
      XmListAddItem(list_w[2],XmStringCreateLocalized(cells[0][group_n]),0);
    for (i=1; i<rows; i++) {
      is_new=1;
      for (j=0; j<i; j++) {
	if (!strcmp(cells[i][group_n],cells[j][group_n])) is_new=0;
      }
      if (is_new)
	if (strtok(cells[i][group_n]," \t\n\0"))
	  XmListAddItem(list_w[2],XmStringCreateLocalized(cells[i][group_n]),0);
    }
  }
  XtVaGetValues(list_w[2], XmNitemCount, &elem_n, NULL);
  if (elem_n<2) showmess(toplevel, UTT_GERR_T, UTT_GERR_M);
  else {
    XmListSelectPos(list_w[2],1,False);
    XmListSelectPos(list_w[2],2,False);
  }
}

void utt_ok_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  Widget               *list_w;
  ttest_struct         *ttest;
  String               **cells, *clabels, e1, e2;
  XmString             *select_list;
  char                 *out_buf, *temp, *pcells, text[256], ftext[4];
  int                  i, j, k, cols, rows, select_n, *select_pos;
  int                  ndata1, ndata2, startgroup;
  float                *data1, *data2;
  float                df, t, prob, a, t95, f, fprob;
  float                ave1, ave2, var1, var2;

  extern void resedit(char *text, char *title);
  extern void getstudt(float df, float p, float *t);
  extern void avevar(float data[], unsigned long n, float *ave, float *var);
  extern void myttest(float data1[], unsigned long n1,
		      float data2[], unsigned long n2,
		      float *df, float *t, float *prob, float *a);
  extern void mytutest(float data1[], unsigned long n1,
		       float data2[], unsigned long n2,
		       float *df, float *t, float *prob, float *b);
  extern void ftest(float data1[], unsigned long n1,
		    float data2[], unsigned long n2,
		    float *f, float *prob);
  extern void showmess(Widget widget, char *title, char *text);

  list_w=(Widget *)client_data;
  XtVaGetValues(widget, XmNuserData, &ttest, NULL);
  XtVaGetValues(StatData, XmNcolumns, &cols, NULL);
  XtVaGetValues(StatData, XmNrows, &rows, NULL);
  XtVaGetValues(StatData, XmNcolumnLabels, &clabels, NULL);
  XtVaGetValues(StatData, XmNcells, &cells, NULL);
  out_buf=new char [OUTBUFLEN];
  temp   =new char [256];
  if (XmListGetSelectedPos(list_w[2], &select_pos, &select_n)) {
    if (select_n != 2)
      showmess(widget, UTT_SELERR_T, UTT_SELERR_M);
    else {
      /* now calculate unpaired t-test */
      XtVaGetValues(list_w[2], XmNitems, &select_list, NULL);
      XmStringGetLtoR(select_list[select_pos[0]-1],XmFONTLIST_DEFAULT_TAG, &e1);
      XmStringGetLtoR(select_list[select_pos[1]-1],XmFONTLIST_DEFAULT_TAG, &e2);
      strcpy(out_buf, "Independent groups Student's t-test \n");
      sprintf(temp, "Group 1: %s = %s \n", clabels[ttest->utt_group_var], e1);
      strcat(out_buf, temp);
      sprintf(temp, "Group 2: %s = %s \n\n", clabels[ttest->utt_group_var], e2);
      strcat(out_buf, temp);
      if (sort.ngroup==1) sort.group[0]=rows;
      startgroup=0;
      for (k=0; k<sort.ngroup; k++) {
	/* Headline */
	for (i=0; i<sort.nsort; i++) {
	  sprintf(temp, "%10s = %10s \n", clabels[sort.sort[i]], cells[startgroup][sort.sort[i]] );
	  strcat(out_buf, temp);
	}
	add_line(out_buf, 75);
	sprintf(temp,
		"%10s %4s %4s %9s %9s %9s %9s %9s %4s\n",
		" ", "n1", "n2", "df", "t", "p", "CI low", "CI high", "F");
	strcat(out_buf, temp);
	add_line(out_buf, 75);
	/* Results */
	data1=new float[sort.group[k]];
	data2=new float[sort.group[k]];
	for (i=0; i<sort.ndep; i++) {  // circle through dependent vars;
	  if (sort.dep[i]!=ttest->utt_group_var) {  // group var. is not a depend. var;
	    ndata1=0; ndata2=0;
	    // get data array;
	    for (j=startgroup; j<startgroup+sort.group[k]; j++) {
	      if (!strcmp(cells[j][ttest->utt_group_var], e1)) {
		data1[ndata1]=strtod(cells[j][sort.dep[i]], &pcells);
		// is it numeric ? ;
		if (data1[ndata1]!=0 || strcmp(pcells,cells[j][sort.dep[i]]))
		  ndata1++;
	      }
	      if (!strcmp(cells[j][ttest->utt_group_var], e2)) {
		data2[ndata2]=strtod(cells[j][sort.dep[i]], &pcells);
		// is it numeric ? ;
		if (data2[ndata2]!=0 || strcmp(pcells,cells[j][sort.dep[i]]))
		  ndata2++;
	      }
	    }
	    // calculate t-test;
	    strncpy(text, clabels[sort.dep[i]], 10); text[10]='\0';
	    if (ndata1>=2 && ndata2>=2) {
	      avevar(data1-1, ndata1, &ave1, &var1);
	      avevar(data2-1, ndata2, &ave2, &var2);
	      // equal variances;
	      myttest(data1-1, ndata1, data2-1, ndata2, &df, &t, &prob, &a);
	      getstudt(df, 0.05, &t95);
	      ftest(data1-1, ndata1, data2-1, ndata2, &f, &fprob);
	      fprob=fprob/2; // ftest() gives the one-tailed p value;
	      if (fprob<=0.05) strcpy(ftext, "eq");
	      else             strcpy(ftext, "eq*");
	      sprintf(temp, "%10s %4d %4d %9.3f %9.3f %9.3f %9.3f %9.3f %4s\n",
		      text, ndata1, ndata2, df, t, prob,
		      (ave1-ave2)-t95*a, (ave1-ave2)+t95*a, ftext);
	      strcat(out_buf, temp);
	      // unequal variances;
	      mytutest(data1-1, ndata1, data2-1, ndata2, &df, &t, &prob, &a);
	      getstudt(df, 0.05, &t95);
	      if (fprob<=0.05) strcpy(ftext, "ueq*");
	      else             strcpy(ftext, "ueq");
	      sprintf(temp, "%10s %4d %4d %9.3f %9.3f %9.3f %9.3f %9.3f %4s\n",
		      text, ndata1, ndata2, df, t, prob,
		      (ave1-ave2)-t95*a, (ave1-ave2)+t95*a, ftext);
	      strcat(out_buf, temp);
	    }
	    else {
	      sprintf(temp, "%10s %4d %4d\n", text, ndata1, ndata2);
	      strcat(out_buf, temp);
	    }
	    add_line(out_buf, 75);
	  }
	}

	delete[]data1; delete[]data2;
	startgroup+=sort.group[k];
	strcat(out_buf, "\n");
      }
      resedit(out_buf, "unpaired t-test");
      XtFree(e1); XtFree(e2);
      XtUnmanageChild(widget);
    }
    XtFree((char *)select_pos);
  }
  else showmess(widget, UTT_SELERR_T, UTT_SELERR_M);

  delete[]temp;
  delete[]out_buf;
}

